/* Processed by ecpg (4.5.0) */
/* These include files are added by the preprocessor */
#include <ecpglib.h>
#include <ecpgerrno.h>
#include <sqlca.h>
/* End of automatic include section */

#line 1 "recv.pgc"
/*
Nome Artefato/Programa..: recv.c
Empresa.................: UFRN-SINFO Universidade Ferderal do Rio Grande do Norte
Autor(es)...............: Emerson Hermann (emersonhermann@gmail.com) (emerson@info.ufrn.br) 
Data Inicio ............: 01/02/2010
Data Atual..............: 01/02/2010
Versao..................: 0.01
Compilador/Interpretador: Postgres(ecpg) 4.5.0/GGNU(gcc)4.3.3 /GNU(gcc)4.2.4 /GNC(gcc) 3.3.4
Sistemas Operacionais...: Linux
SGBD....................: Postgres 8.3 / 8.4     
Kernel..................: testado (2.6.29.6) (2.6.27-7) (2.6.21-5) (2.4.49 com lib krb5-1.4.2-i486-2ttw.tgz)
Finalidade..............: Processar e receber arquivos do log do Postgres 
OBS.....................: SQL Embedded 
*/
#include <stdio.h>      // o basico1 
#include <stdlib.h>     // o basico2 
//#include <process.h> 	// ativar para plataforma Windows 
#include <memory.h>     // o proprio nome ja diz  
#include <string.h>     // idem ao anterior   
#include <errno.h> 	// tratamento de erros  
#include <strings.h>    // tratamento de strings
#include <sys/types.h> 	// necessario para o daemonInit
#include <sys/stat.h> 	// necessario para o daemonInit
#include <fcntl.h> 	// necessario para o daemonInit
#include <unistd.h> 	// necessario no Unix/Linux para a funcao sleep
#include <time.h> 	// funcoes time_t, time, gmtime, localtime

/* exec sql begin declare section */

  //const char databasename [140] = "tcp:postgresql://10.0.2.15/test";
 
  // Conexao localhost
       
 
      
      
   
  //struct varchar_var  { int len; char arr[14]; } codigo_volume;
    
   
   
 


#line 33 "recv.pgc"
 const char databasename [ 140 ] = "tcp:postgresql://localhost:5432/pglogger" ;
 
#line 35 "recv.pgc"
 const char userx [ 10 ] = "postgres" ;
 
#line 36 "recv.pgc"
 const char passx [ 10 ] = "postgres" ;
 
#line 37 "recv.pgc"
 int id_pesagem ;
 
#line 39 "recv.pgc"
 char codigo_volume [ 14 ] ;
 
#line 40 "recv.pgc"
 float peso_bruto ;
 
#line 41 "recv.pgc"
 long lCountDb ;
/* exec sql end declare section */
#line 44 "recv.pgc"


/* Incluso da Estrutura p/Tratamento de Erros - SQLCA */

#line 1 "/usr/local/pgsql/include/sqlca.h"
#ifndef POSTGRES_SQLCA_H
#define POSTGRES_SQLCA_H

#ifndef PGDLLIMPORT
#if  defined(WIN32) || defined(__CYGWIN__)
#define PGDLLIMPORT __declspec (dllimport)
#else
#define PGDLLIMPORT
#endif   /* __CYGWIN__ */
#endif   /* PGDLLIMPORT */

#define SQLERRMC_LEN	150

#ifdef __cplusplus
extern		"C"
{
#endif

struct sqlca_t
{
	char		sqlcaid[8];
	long		sqlabc;
	long		sqlcode;
	struct
	{
		int			sqlerrml;
		char		sqlerrmc[SQLERRMC_LEN];
	}			sqlerrm;
	char		sqlerrp[8];
	long		sqlerrd[6];
	/* Element 0: empty						*/
	/* 1: OID of processed tuple if applicable			*/
	/* 2: number of rows processed				*/
	/* after an INSERT, UPDATE or				*/
	/* DELETE statement					*/
	/* 3: empty						*/
	/* 4: empty						*/
	/* 5: empty						*/
	char		sqlwarn[8];
	/* Element 0: set to 'W' if at least one other is 'W'	*/
	/* 1: if 'W' at least one character string		*/
	/* value was truncated when it was			*/
	/* stored into a host variable.				*/

	/*
	 * 2: if 'W' a (hopefully) non-fatal notice occurred
	 */	/* 3: empty */
	/* 4: empty						*/
	/* 5: empty						*/
	/* 6: empty						*/
	/* 7: empty						*/

	char		sqlstate[5];
};

struct sqlca_t *ECPGget_sqlca(void);

#ifndef POSTGRES_ECPG_INTERNAL
#define sqlca (*ECPGget_sqlca())
#endif

#ifdef __cplusplus
}
#endif

#endif

#line 47 "recv.pgc"


long    error=0L;


long printMsgError (void);

/***********************************************************
 *  Function connectDataBase ==> Conecta ao DB Postgres  *
 ***********************************************************/
int connectDataBase(void)
{
  /* Conecta ao Database */

  { ECPGconnect(__LINE__, 0, databasename , userx , passx , "myconnect", 0); }
#line 61 "recv.pgc"
 
  
  //EXEC SQL CONNECT TO "tcp:postgresql://10.0.2.15:5432/test" AS myconnect USER pgsql IDENTIFIED BY pgsql; 
  // Conexao localhost
  //EXEC SQL CONNECT TO :databasename ; 
  error = printMsgError();

  if (error) 
  {
    printf("\nSQL ERROR> Nao foi possivel conectar ao Postgres Server!\n");
    exit(1);
  }
  
}

/*************************************************************
 *Function disconnectDataBase ==> Desconecta do DB Postgres*
 *************************************************************/
void disconnectDataBase(void)
{
  long lRet;

  /* Desconecta do Database atualmente conectado  */
  /* exec sql whenever sqlerror  continue ; */
#line 84 "recv.pgc"

  { ECPGdisconnect(__LINE__, "CURRENT");}
#line 85 "recv.pgc"

  printf ("SQL> Desconectando o Postgres...\n");

  if (SQLCODE)
  {
    printf("\nSQL> Detectado Erro na Desconexao no Postgres!\n");
    lRet = printMsgError();
    { ECPGtrans(__LINE__, NULL, "rollback");}
#line 92 "recv.pgc"

    exit (0);
  }

  printf ("SQL> Desconexao do Postgres Realizada com Sucesso!\n");
  exit(1);

}

/***************************************************************
 *  Function PrintMsgError ==> Imprime uma Mensagem de Erro    *
 *                             refletindo o SQLCODE retornado  *
 *			       pelo Postgres                 *
 ***************************************************************/
long printMsgError (void)
{
  if (SQLCODE)
  {
    printf ("\nSQL ERROR> Postgres Error Code = %d.\n", SQLCODE);
  }
  return (SQLCODE);
}

/***************************************************************
 *  Function execExport ==> SELECT *                           * 
 *                            FROM postgres_log                *
 *                           WHERE export IS FALSE             *
 ***************************************************************/
int execExport (void)
{

  int        iFd;  		  // ponteiro do arquivo de importacao (Unix/Linux)
  char       szBuffer[300]; 	  // para armazenar strings de comandos dml no arquivo de importacao
  time_t     stHora_sist; 	  // Para armazenar a data hora do sistema em quantidade de segundos 
  struct tm  *ST_Hora_exp;    	  // Para armazenar o formato expandido da data 

  FILE       *fLsDir;  		  // ponteiro do arquivo que contem listagem de arquivos no diretorio (Unix/Linux) (descritor)
  FILE       *fLsTotalDir;        // ponteiro arquivo que contem total listagem arquivos no diretorio (Unix/Linux) (descritor)
  char       szLsDir[300] = "/tmp/lsdir.txt";  // nome do arquivo com listagem dos arquivos de importacao
  char       szLsTotalDir[300] = "/tmp/ttfiledir.txt";  // nome do arquivo com total de listagem dos arquivos de importacao
  char       *szPsql[300];        // string de comando do psql
  char       *szRmVector[300];    // string de comando do rm szVector 
  char       *szCpVector[400];    // string de comando do cp szVector 
  int        i, j;                // controle de loop 
  char       szVector [7000][100]; // vetor de string
  char       *pchNameFileDir;     // nome do arquivo no diretorio com listagem
  char       *pchNameTotalFileDir;     // nome do arquivo no diretorio com total de arquivos 

  /*
    desabilitando o log do Postgres
  */
  /*
  EXEC SQL 
          SET log_statement TO 'none'; 

  */	  

  int retExec  = system("ls -1cr /usr/local/pgsql/data/pg_log/*.csv > /tmp/lsdir.txt");
  int retExec2 = system("ls /usr/local/pgsql/data/pg_log/*.csv -F | wc -l > /tmp/ttfiledir.txt");
  printf ("Retornou do SO: %d-%d\n",retExec,retExec2);


  
  // se executou com problemas
  if (retExec != 0) 
  {
  
    return (0);
    
  } else {
  
    /* Abre arquivo com a devida permissao no SO */
    fLsDir = fopen ("/tmp/lsdir.txt", "r");


    if (fLsDir == NULL)
    {
      fprintf (stderr,"Erro: %s\n", strerror(errno));
      exit (0);
    }

    /* Abre arquivo com a devida permissao no SO */
    fLsTotalDir = fopen ("/tmp/ttfiledir.txt", "r");

    if (fLsTotalDir == NULL)
    {
      fprintf (stderr,"Erro: %s\n", strerror(errno));
      exit (0);
    }

    //pchNameTotalFileDir = fgets (1, 100, fLsTotalDir);





    i = 0;


    while (1)
    {

            	    
      pchNameFileDir = fgets (szVector [i], 100, fLsDir);


      // se encontrou o fim do arquivo 
      if (pchNameFileDir == NULL) 
      {
        break;
      }
      i++;
      //printf ("Ate aqui nos ajudou o Senhor!  %d\n",i);


    }
    

    // o arquivo do momento nao vai no processamento
    for (j=0; j < i-1; j++) 
    {
    
      /* removendo string \0 (null) */
      delENull(szVector[j]);  

      /* removendo string espaco */
      delESpaces(szVector[j]);  

      //printf ("Debug arquivo:%s:\n",szVector[j]);
      
      stHora_sist = time(NULL); // total em segundos
      ST_Hora_exp = localtime (&stHora_sist); // obtendo a data expandida considerando o timezone      
      //printf ("Debug arquivo:%s:\n",szVector[j]);


      /* executando a importacao do arquivo  no banco */
      sprintf (szPsql,"psql -d pglogger -U postgres -c \"COPY postgres_log FROM '%s' WITH CSV\"> /dev/null\n",szVector[j]);
      //printf ("Debug connteudo: %s\n",szPsql);
      //printf ("Debug memoria: %d\n",szPsql);
      //printf ("Debug arquivo %s\n",szVector[j]);
      system(szPsql);

      /* copiando arquivos processados para o diretorio apropriado /usr/local/pgsql/data/proc*/ 

      sprintf(szCpVector,"mv %s %s.proc \n",szVector[j],szVector[j]);
      //printf("Debug copia: %s\n",szCpVector);
      system(szCpVector);
      
      /* elminando arquivo do diretorio /usr/local/pgsql/data/pg_log */
      sprintf(szRmVector,"mv  /usr/local/pgsql/data/pg_log/*.proc /usr/local/pgsql/data/proc \n",szVector[j]);
      //printf("Debug del: %s",szRmVector);
      system(szRmVector);

      /*

      EXEC SQL 
              SELECT * FROM postgres_log;


      */


      /* So por seguranca, para evitar gasto de processamento 
       * caso ocorra algum erro no processamento da(s) query(s)
       * evitando perder tempo com algo com problemas - desativado
      */
   
      if (SQLCODE)
      {
        printMsgError();
        return (0);
      }
  

      /* Caso a transacao seja efetuada sem 
       * problemas, sera efetuado um COMMIT e
       * geracao de arquivo de exportacao,
       * caso contrario sera efetuado ROLLBACK
      */
  

      if (SQLCODE = printMsgError())
      {
        { ECPGtrans(__LINE__, NULL, "rollback");}
#line 275 "recv.pgc"

        printf ("SQL ERROR> Erro na Executacao da Query...\n");
      }




      
    }

    printf ("Arquivo(s) lido(s): %d\n",i-1);
    printf ("INFO> Registro(s) processado(s)!\n");


    /* fechando o arquivo */
    fclose (fLsDir);

    /* renomeando o arquivo */
    //rename(iLsDir);
 


    return (0);
  } 
}


/***************************************************************
 *  Function cleanFiles ==> Funcao para eliminar arquivos      *
 *                           temporarios gerados no processo   *
 *                           (Linux / Unix)                    *
 ***************************************************************/
int cleanFiles (void)
{
  /* eliminando arquivos temporarios */
  system("rm -f /tmp/lsdir.log");
  system("rm -f /usr/local/pgsql/data/pg_log/*.log");
  system("rm -f /tmp/ttfiledir.log");

}

/***************************************************************
 *  Function delESpaces ==> Funcao para eliminar espacos       *
 *                           em strings no final da string     *
 ***************************************************************/
int delESpaces(char* str)
{
  int i;
     
  if(!str) 
  {
    return -1;
  } else {
    for(i=strlen(str);str[i-1]==' ';i--)
    {
      str[i-1]='\0';
    }
    return i;
  }
}
/***************************************************************
 *  Function delENull ==> Funcao para eliminar null no final   * 
 *                         da string                           *
 ***************************************************************/
int delENull(char* str)
{

  int i;
  char strx; 
     
  if(!str) 
  {
    return -1;
  } else {
    i=strlen(str);
    
    str[i-1]=' ';
    return 0;

  }
}


/***************************************************************
 *  Function daemonInit ==> Funcao para tramsformar processo   *
 *                           terminal em processo daemon       *
 *                           (Linux / Unix)                    *
 ***************************************************************/
int daemonInit (void)
{
  pid_t     iPid;
  long      iMaxFd;
  int       i;

  /* 1o. Passo - Duplica o processo usando fork. 
   * O processo pai eh encerrado.
   */

  if ((iPid = fork()) < 0)
    return -1;

  if (iPid != 0)
    exit(0);


  /* 2o. Passo - Chama a funcao setsid para criar uma nova sessao de processo, 
   * ficando o processo filho como lider da sessao e sem um terminal de
controle 
   * associado ao processo 
   */

  setsid();

  /* 3o. Passo - Mudando para o diretorio raiz (root) ou para o diretorio 
   * proprio do daemon 
   */

  chdir ("/");

  /* 4o. Passo - Inicializa a mascara padrao de criacao (permissao) de arquivos
 
   */

  umask (0);

  /* 5o. Passo - Fechando todos descritores existentes no sistema. Utiliza-se a
informacao
   * de numero maximo de descritores configurado no sistema, obtido com a funcao
sysconf.
   * Para outras opcoes da funcao sysconf, favor verificar o manual on-line do
sistema
   */

  iMaxFd = sysconf (_SC_OPEN_MAX);
  for (i=0; i < iMaxFd; i++)
  {
    close (i);
  }

  return 0;
}


#if defined(UNIX) || defined(WINNT)
  void sighandler(sig)
  int sig;
  {
    exit(0);
  }
#endif


/*******************
 *  FUNCTION MAIN  *
 *******************/
int main (int argc, char *argv[])
{

  char       szNameFile[300]; 	// para armazenar nome do arquivo
  char       szFileName[300];   // arquivo a ser importado 
  char       *szClear = "clear";

  system(szClear);
  szClear = NULL;
  printf ("**************************************************************\n");
  printf ("**          pgLogger - Processa logs do Postgres            **\n");
  printf ("**                   recv - Versao 0.1                      **\n");
  printf ("** -                 Desenvolvido por:                    - **\n"); 
  printf ("** - Emerson Hermann - Email: (emersonhermann@gmail.com)  - **\n"); 
  printf ("**                       Agradecimentos                     **\n"); 
  printf ("**                 Obrigado JESUS por tudo !!!!             **\n"); 
  printf ("**************************************************************\n\n");

  /* Adaptacoes futuras para Windows / Linux / Unix */

  #if defined(UNIX) || defined(WINNT)
    signal(SIGINT,(void (__cdecl *) (int))sighandler);
    signal(SIGTERM,(void (__cdecl *) (int))sighandler);
    signal(SIGSEGV,(void (__cdecl *) (int))sighandler);
  #ifndef UNIX
    signal(SIGQUIT,sighandler);
    signal(SIGBUS,sighandler);
    signal(SIGHUP,sighandler);
  #endif
  #endif

  /* Aqui faz a brincadeira de rodar em daemon */ 
 
    
  if (daemonInit () < 0) 
  {
    perror (argv[0]);  	  
    exit (errno);		
  }
  
 

  /* Conectar ao Postgres */
  connectDataBase();

  /* Apenas para tratar o erro do SQL, continuar rodando caso encontre erro */
  /* exec sql whenever sqlerror  continue ; */
#line 476 "recv.pgc"



  while (1)
  {

	  
    // Processo de execucao da importacao de arquivos 	
    
    execExport();
    

    // Delay, tempo de intervalo de execucao em segundos 
    sleep(5);
    

    /* Arquivo de teste */
    
    /* 
    char szFileName[300] = "cat /proc/meminfo >> /tmp/test_1.txt";

    system(szFileName);
    */

    // elminar arquivos temporario gerados pelo processo 
    cleanFiles();


  }


  /* Este artefato rodara eternamente em processo daemon (function daemonInit), 
   * nao sendo necessario fechar conexao, mas por precaucao caso seja dado um  
   * kill no processo, havera uma tentativa de fechamento da conexao
   * com o banco, muito embora ja exista algo para tratamento desta situacao. 
   */


  disconnectDataBase ();
}

